import org.ejml.simple.SimpleMatrix;

public class ActivationFunctions {
    public static SimpleMatrix tanh(SimpleMatrix A) {
        SimpleMatrix B = new SimpleMatrix(A);
        for (int i = 0; i < A.getNumElements(); i++) {
            B.set(i, Math.tanh(A.get(i)));
        }
        return B;
    }

    public static SimpleMatrix tanhPrime(SimpleMatrix A) {
        SimpleMatrix B = new SimpleMatrix(A);
        for (int i = 0; i < A.getNumElements(); i++) {
            B.set(i, 1 - Math.pow(Math.tanh(A.get(i)), 2));
        }
        return B;
    }

    public static SimpleMatrix logistic(SimpleMatrix A) {
        SimpleMatrix B = new SimpleMatrix(A);
        for (int i = 0; i < A.getNumElements(); i++) {
            B.set(i, sigma(-A.get(i)));
        }
        return B;
    }

    public static SimpleMatrix logisticPrime(SimpleMatrix A) {
        SimpleMatrix B = new SimpleMatrix(A);
        for (int i = 0; i < A.getNumElements(); i++) {
            B.set(i, sigma(A.get(i) * (1 - sigma(A.get(i)))));
        }
        return B;
    }

    private static double sigma(double value) {
        return 1 / (1 + Math.exp(-value));
    }

    public static SimpleMatrix ReLu(SimpleMatrix A) {
        SimpleMatrix B = new SimpleMatrix(A);
        for (int i = 0; i < A.getNumElements(); i++) {
            B.set(i, Math.max(0, A.get(i)));
        }
        return B;
    }

    public static SimpleMatrix ReLuPrime(SimpleMatrix A) {
        SimpleMatrix B = new SimpleMatrix(A);
        for (int i = 0; i < A.getNumElements(); i++) {
            B.set(i, A.get(i) < 0 ? 0 : 1);
        }
        return B;
    }
}
